"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const writeJsonFile = require("write-json-file");
const publishToDir_1 = require("./publishToDir");
const pnpmExec_1 = require("./pnpmExec");
function default_1(what, where) {
    return __awaiter(this, void 0, void 0, function* () {
        const pkgDir = path.resolve(what);
        where = path.resolve(where);
        const previewDir = path.join(pkgDir, '..', `${path.basename(pkgDir)}.preview`);
        const distDir = path.join(previewDir, 'package');
        yield publishToDir_1.default(pkgDir, distDir);
        const pkg = require(path.join(distDir, 'package.json'));
        const wrapperPkg = {
            dependencies: pkg.peerDependencies || {},
        };
        // We don't want to install dev dependencies
        // there has to be a better way, for instance, runnin `pnpm install --production`
        // However, currently `pnpm link` would install all deps, so this hack is needed
        delete pkg.devDependencies;
        // Would be better to install the package dirrectly from the tarball
        // in that case this hack would not be needed
        if (pkg.scripts) {
            delete pkg.scripts.prepare;
            delete pkg.scripts.prepublish;
        }
        yield writeJsonFile(path.join(distDir, 'package.json'), pkg);
        yield writeJsonFile(path.join(previewDir, 'package.json'), wrapperPkg);
        yield pnpmExec_1.default({
            prefix: previewDir,
            args: ['install'],
        });
        yield pnpmExec_1.default({
            prefix: distDir,
            args: ['link']
        });
        yield pnpmExec_1.default({
            args: ['link', pkg.name],
            prefix: where,
        });
    });
}
exports.default = default_1;
//# sourceMappingURL=index.js.map